"use strict";
/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAttestationEncoder = getAttestationEncoder;
exports.getAttestationDecoder = getAttestationDecoder;
exports.getAttestationCodec = getAttestationCodec;
exports.decodeAttestation = decodeAttestation;
exports.fetchAttestation = fetchAttestation;
exports.fetchMaybeAttestation = fetchMaybeAttestation;
exports.fetchAllAttestation = fetchAllAttestation;
exports.fetchAllMaybeAttestation = fetchAllMaybeAttestation;
const kit_1 = require("@solana/kit");
function getAttestationEncoder() {
    return (0, kit_1.getStructEncoder)([
        ['discriminator', (0, kit_1.getU8Encoder)()],
        ['nonce', (0, kit_1.getAddressEncoder)()],
        ['credential', (0, kit_1.getAddressEncoder)()],
        ['schema', (0, kit_1.getAddressEncoder)()],
        ['data', (0, kit_1.addEncoderSizePrefix)((0, kit_1.getBytesEncoder)(), (0, kit_1.getU32Encoder)())],
        ['signer', (0, kit_1.getAddressEncoder)()],
        ['expiry', (0, kit_1.getI64Encoder)()],
        ['tokenAccount', (0, kit_1.getAddressEncoder)()],
    ]);
}
function getAttestationDecoder() {
    return (0, kit_1.getStructDecoder)([
        ['discriminator', (0, kit_1.getU8Decoder)()],
        ['nonce', (0, kit_1.getAddressDecoder)()],
        ['credential', (0, kit_1.getAddressDecoder)()],
        ['schema', (0, kit_1.getAddressDecoder)()],
        ['data', (0, kit_1.addDecoderSizePrefix)((0, kit_1.getBytesDecoder)(), (0, kit_1.getU32Decoder)())],
        ['signer', (0, kit_1.getAddressDecoder)()],
        ['expiry', (0, kit_1.getI64Decoder)()],
        ['tokenAccount', (0, kit_1.getAddressDecoder)()],
    ]);
}
function getAttestationCodec() {
    return (0, kit_1.combineCodec)(getAttestationEncoder(), getAttestationDecoder());
}
function decodeAttestation(encodedAccount) {
    return (0, kit_1.decodeAccount)(encodedAccount, getAttestationDecoder());
}
async function fetchAttestation(rpc, address, config) {
    const maybeAccount = await fetchMaybeAttestation(rpc, address, config);
    (0, kit_1.assertAccountExists)(maybeAccount);
    return maybeAccount;
}
async function fetchMaybeAttestation(rpc, address, config) {
    const maybeAccount = await (0, kit_1.fetchEncodedAccount)(rpc, address, config);
    return decodeAttestation(maybeAccount);
}
async function fetchAllAttestation(rpc, addresses, config) {
    const maybeAccounts = await fetchAllMaybeAttestation(rpc, addresses, config);
    (0, kit_1.assertAccountsExist)(maybeAccounts);
    return maybeAccounts;
}
async function fetchAllMaybeAttestation(rpc, addresses, config) {
    const maybeAccounts = await (0, kit_1.fetchEncodedAccounts)(rpc, addresses, config);
    return maybeAccounts.map((maybeAccount) => decodeAttestation(maybeAccount));
}
