"use strict";
/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCredentialEncoder = getCredentialEncoder;
exports.getCredentialDecoder = getCredentialDecoder;
exports.getCredentialCodec = getCredentialCodec;
exports.decodeCredential = decodeCredential;
exports.fetchCredential = fetchCredential;
exports.fetchMaybeCredential = fetchMaybeCredential;
exports.fetchAllCredential = fetchAllCredential;
exports.fetchAllMaybeCredential = fetchAllMaybeCredential;
const kit_1 = require("@solana/kit");
function getCredentialEncoder() {
    return (0, kit_1.getStructEncoder)([
        ['discriminator', (0, kit_1.getU8Encoder)()],
        ['authority', (0, kit_1.getAddressEncoder)()],
        ['name', (0, kit_1.addEncoderSizePrefix)((0, kit_1.getBytesEncoder)(), (0, kit_1.getU32Encoder)())],
        ['authorizedSigners', (0, kit_1.getArrayEncoder)((0, kit_1.getAddressEncoder)())],
    ]);
}
function getCredentialDecoder() {
    return (0, kit_1.getStructDecoder)([
        ['discriminator', (0, kit_1.getU8Decoder)()],
        ['authority', (0, kit_1.getAddressDecoder)()],
        ['name', (0, kit_1.addDecoderSizePrefix)((0, kit_1.getBytesDecoder)(), (0, kit_1.getU32Decoder)())],
        ['authorizedSigners', (0, kit_1.getArrayDecoder)((0, kit_1.getAddressDecoder)())],
    ]);
}
function getCredentialCodec() {
    return (0, kit_1.combineCodec)(getCredentialEncoder(), getCredentialDecoder());
}
function decodeCredential(encodedAccount) {
    return (0, kit_1.decodeAccount)(encodedAccount, getCredentialDecoder());
}
async function fetchCredential(rpc, address, config) {
    const maybeAccount = await fetchMaybeCredential(rpc, address, config);
    (0, kit_1.assertAccountExists)(maybeAccount);
    return maybeAccount;
}
async function fetchMaybeCredential(rpc, address, config) {
    const maybeAccount = await (0, kit_1.fetchEncodedAccount)(rpc, address, config);
    return decodeCredential(maybeAccount);
}
async function fetchAllCredential(rpc, addresses, config) {
    const maybeAccounts = await fetchAllMaybeCredential(rpc, addresses, config);
    (0, kit_1.assertAccountsExist)(maybeAccounts);
    return maybeAccounts;
}
async function fetchAllMaybeCredential(rpc, addresses, config) {
    const maybeAccounts = await (0, kit_1.fetchEncodedAccounts)(rpc, addresses, config);
    return maybeAccounts.map((maybeAccount) => decodeCredential(maybeAccount));
}
