"use strict";
/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSchemaEncoder = getSchemaEncoder;
exports.getSchemaDecoder = getSchemaDecoder;
exports.getSchemaCodec = getSchemaCodec;
exports.decodeSchema = decodeSchema;
exports.fetchSchema = fetchSchema;
exports.fetchMaybeSchema = fetchMaybeSchema;
exports.fetchAllSchema = fetchAllSchema;
exports.fetchAllMaybeSchema = fetchAllMaybeSchema;
const kit_1 = require("@solana/kit");
function getSchemaEncoder() {
    return (0, kit_1.getStructEncoder)([
        ['discriminator', (0, kit_1.getU8Encoder)()],
        ['credential', (0, kit_1.getAddressEncoder)()],
        ['name', (0, kit_1.addEncoderSizePrefix)((0, kit_1.getBytesEncoder)(), (0, kit_1.getU32Encoder)())],
        ['description', (0, kit_1.addEncoderSizePrefix)((0, kit_1.getBytesEncoder)(), (0, kit_1.getU32Encoder)())],
        ['layout', (0, kit_1.addEncoderSizePrefix)((0, kit_1.getBytesEncoder)(), (0, kit_1.getU32Encoder)())],
        ['fieldNames', (0, kit_1.addEncoderSizePrefix)((0, kit_1.getBytesEncoder)(), (0, kit_1.getU32Encoder)())],
        ['isPaused', (0, kit_1.getBooleanEncoder)()],
        ['version', (0, kit_1.getU8Encoder)()],
    ]);
}
function getSchemaDecoder() {
    return (0, kit_1.getStructDecoder)([
        ['discriminator', (0, kit_1.getU8Decoder)()],
        ['credential', (0, kit_1.getAddressDecoder)()],
        ['name', (0, kit_1.addDecoderSizePrefix)((0, kit_1.getBytesDecoder)(), (0, kit_1.getU32Decoder)())],
        ['description', (0, kit_1.addDecoderSizePrefix)((0, kit_1.getBytesDecoder)(), (0, kit_1.getU32Decoder)())],
        ['layout', (0, kit_1.addDecoderSizePrefix)((0, kit_1.getBytesDecoder)(), (0, kit_1.getU32Decoder)())],
        ['fieldNames', (0, kit_1.addDecoderSizePrefix)((0, kit_1.getBytesDecoder)(), (0, kit_1.getU32Decoder)())],
        ['isPaused', (0, kit_1.getBooleanDecoder)()],
        ['version', (0, kit_1.getU8Decoder)()],
    ]);
}
function getSchemaCodec() {
    return (0, kit_1.combineCodec)(getSchemaEncoder(), getSchemaDecoder());
}
function decodeSchema(encodedAccount) {
    return (0, kit_1.decodeAccount)(encodedAccount, getSchemaDecoder());
}
async function fetchSchema(rpc, address, config) {
    const maybeAccount = await fetchMaybeSchema(rpc, address, config);
    (0, kit_1.assertAccountExists)(maybeAccount);
    return maybeAccount;
}
async function fetchMaybeSchema(rpc, address, config) {
    const maybeAccount = await (0, kit_1.fetchEncodedAccount)(rpc, address, config);
    return decodeSchema(maybeAccount);
}
async function fetchAllSchema(rpc, addresses, config) {
    const maybeAccounts = await fetchAllMaybeSchema(rpc, addresses, config);
    (0, kit_1.assertAccountsExist)(maybeAccounts);
    return maybeAccounts;
}
async function fetchAllMaybeSchema(rpc, addresses, config) {
    const maybeAccounts = await (0, kit_1.fetchEncodedAccounts)(rpc, addresses, config);
    return maybeAccounts.map((maybeAccount) => decodeSchema(maybeAccount));
}
