/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlySignerAccount, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/kit';
import { SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS } from '../programs';
export declare const CHANGE_AUTHORIZED_SIGNERS_DISCRIMINATOR = 3;
export declare function getChangeAuthorizedSignersDiscriminatorBytes(): import("@solana/kit").ReadonlyUint8Array;
export type ChangeAuthorizedSignersInstruction<TProgram extends string = typeof SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS, TAccountPayer extends string | IAccountMeta<string> = string, TAccountAuthority extends string | IAccountMeta<string> = string, TAccountCredential extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountAuthority extends string ? ReadonlySignerAccount<TAccountAuthority> & IAccountSignerMeta<TAccountAuthority> : TAccountAuthority,
    TAccountCredential extends string ? WritableAccount<TAccountCredential> : TAccountCredential,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type ChangeAuthorizedSignersInstructionData = {
    discriminator: number;
    signers: Array<Address>;
};
export type ChangeAuthorizedSignersInstructionDataArgs = {
    signers: Array<Address>;
};
export declare function getChangeAuthorizedSignersInstructionDataEncoder(): Encoder<ChangeAuthorizedSignersInstructionDataArgs>;
export declare function getChangeAuthorizedSignersInstructionDataDecoder(): Decoder<ChangeAuthorizedSignersInstructionData>;
export declare function getChangeAuthorizedSignersInstructionDataCodec(): Codec<ChangeAuthorizedSignersInstructionDataArgs, ChangeAuthorizedSignersInstructionData>;
export type ChangeAuthorizedSignersInput<TAccountPayer extends string = string, TAccountAuthority extends string = string, TAccountCredential extends string = string, TAccountSystemProgram extends string = string> = {
    payer: TransactionSigner<TAccountPayer>;
    authority: TransactionSigner<TAccountAuthority>;
    /** Credential the Schema is associated with */
    credential: Address<TAccountCredential>;
    systemProgram?: Address<TAccountSystemProgram>;
    signers: ChangeAuthorizedSignersInstructionDataArgs['signers'];
};
export declare function getChangeAuthorizedSignersInstruction<TAccountPayer extends string, TAccountAuthority extends string, TAccountCredential extends string, TAccountSystemProgram extends string, TProgramAddress extends Address = typeof SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS>(input: ChangeAuthorizedSignersInput<TAccountPayer, TAccountAuthority, TAccountCredential, TAccountSystemProgram>, config?: {
    programAddress?: TProgramAddress;
}): ChangeAuthorizedSignersInstruction<TProgramAddress, TAccountPayer, TAccountAuthority, TAccountCredential, TAccountSystemProgram>;
export type ParsedChangeAuthorizedSignersInstruction<TProgram extends string = typeof SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        payer: TAccountMetas[0];
        authority: TAccountMetas[1];
        /** Credential the Schema is associated with */
        credential: TAccountMetas[2];
        systemProgram: TAccountMetas[3];
    };
    data: ChangeAuthorizedSignersInstructionData;
};
export declare function parseChangeAuthorizedSignersInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedChangeAuthorizedSignersInstruction<TProgram, TAccountMetas>;
