/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlySignerAccount, type TransactionSigner, type WritableAccount } from '@solana/kit';
import { SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS } from '../programs';
export declare const CHANGE_SCHEMA_DESCRIPTION_DISCRIMINATOR = 4;
export declare function getChangeSchemaDescriptionDiscriminatorBytes(): import("@solana/kit").ReadonlyUint8Array;
export type ChangeSchemaDescriptionInstruction<TProgram extends string = typeof SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS, TAccountAuthority extends string | IAccountMeta<string> = string, TAccountCredential extends string | IAccountMeta<string> = string, TAccountSchema extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountAuthority extends string ? ReadonlySignerAccount<TAccountAuthority> & IAccountSignerMeta<TAccountAuthority> : TAccountAuthority,
    TAccountCredential extends string ? ReadonlyAccount<TAccountCredential> : TAccountCredential,
    TAccountSchema extends string ? WritableAccount<TAccountSchema> : TAccountSchema,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type ChangeSchemaDescriptionInstructionData = {
    discriminator: number;
    description: string;
};
export type ChangeSchemaDescriptionInstructionDataArgs = {
    description: string;
};
export declare function getChangeSchemaDescriptionInstructionDataEncoder(): Encoder<ChangeSchemaDescriptionInstructionDataArgs>;
export declare function getChangeSchemaDescriptionInstructionDataDecoder(): Decoder<ChangeSchemaDescriptionInstructionData>;
export declare function getChangeSchemaDescriptionInstructionDataCodec(): Codec<ChangeSchemaDescriptionInstructionDataArgs, ChangeSchemaDescriptionInstructionData>;
export type ChangeSchemaDescriptionInput<TAccountAuthority extends string = string, TAccountCredential extends string = string, TAccountSchema extends string = string, TAccountSystemProgram extends string = string> = {
    authority: TransactionSigner<TAccountAuthority>;
    /** Credential the Schema is associated with */
    credential: Address<TAccountCredential>;
    /** Credential the Schema is associated with */
    schema: Address<TAccountSchema>;
    systemProgram?: Address<TAccountSystemProgram>;
    description: ChangeSchemaDescriptionInstructionDataArgs['description'];
};
export declare function getChangeSchemaDescriptionInstruction<TAccountAuthority extends string, TAccountCredential extends string, TAccountSchema extends string, TAccountSystemProgram extends string, TProgramAddress extends Address = typeof SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS>(input: ChangeSchemaDescriptionInput<TAccountAuthority, TAccountCredential, TAccountSchema, TAccountSystemProgram>, config?: {
    programAddress?: TProgramAddress;
}): ChangeSchemaDescriptionInstruction<TProgramAddress, TAccountAuthority, TAccountCredential, TAccountSchema, TAccountSystemProgram>;
export type ParsedChangeSchemaDescriptionInstruction<TProgram extends string = typeof SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        authority: TAccountMetas[0];
        /** Credential the Schema is associated with */
        credential: TAccountMetas[1];
        /** Credential the Schema is associated with */
        schema: TAccountMetas[2];
        systemProgram: TAccountMetas[3];
    };
    data: ChangeSchemaDescriptionInstructionData;
};
export declare function parseChangeSchemaDescriptionInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedChangeSchemaDescriptionInstruction<TProgram, TAccountMetas>;
