/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlySignerAccount, type TransactionSigner, type WritableAccount } from '@solana/kit';
import { SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS } from '../programs';
export declare const CHANGE_SCHEMA_STATUS_DISCRIMINATOR = 2;
export declare function getChangeSchemaStatusDiscriminatorBytes(): import("@solana/kit").ReadonlyUint8Array;
export type ChangeSchemaStatusInstruction<TProgram extends string = typeof SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS, TAccountAuthority extends string | IAccountMeta<string> = string, TAccountCredential extends string | IAccountMeta<string> = string, TAccountSchema extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountAuthority extends string ? ReadonlySignerAccount<TAccountAuthority> & IAccountSignerMeta<TAccountAuthority> : TAccountAuthority,
    TAccountCredential extends string ? ReadonlyAccount<TAccountCredential> : TAccountCredential,
    TAccountSchema extends string ? WritableAccount<TAccountSchema> : TAccountSchema,
    ...TRemainingAccounts
]>;
export type ChangeSchemaStatusInstructionData = {
    discriminator: number;
    isPaused: boolean;
};
export type ChangeSchemaStatusInstructionDataArgs = {
    isPaused: boolean;
};
export declare function getChangeSchemaStatusInstructionDataEncoder(): Encoder<ChangeSchemaStatusInstructionDataArgs>;
export declare function getChangeSchemaStatusInstructionDataDecoder(): Decoder<ChangeSchemaStatusInstructionData>;
export declare function getChangeSchemaStatusInstructionDataCodec(): Codec<ChangeSchemaStatusInstructionDataArgs, ChangeSchemaStatusInstructionData>;
export type ChangeSchemaStatusInput<TAccountAuthority extends string = string, TAccountCredential extends string = string, TAccountSchema extends string = string> = {
    authority: TransactionSigner<TAccountAuthority>;
    /** Credential the Schema is associated with */
    credential: Address<TAccountCredential>;
    /** Credential the Schema is associated with */
    schema: Address<TAccountSchema>;
    isPaused: ChangeSchemaStatusInstructionDataArgs['isPaused'];
};
export declare function getChangeSchemaStatusInstruction<TAccountAuthority extends string, TAccountCredential extends string, TAccountSchema extends string, TProgramAddress extends Address = typeof SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS>(input: ChangeSchemaStatusInput<TAccountAuthority, TAccountCredential, TAccountSchema>, config?: {
    programAddress?: TProgramAddress;
}): ChangeSchemaStatusInstruction<TProgramAddress, TAccountAuthority, TAccountCredential, TAccountSchema>;
export type ParsedChangeSchemaStatusInstruction<TProgram extends string = typeof SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        authority: TAccountMetas[0];
        /** Credential the Schema is associated with */
        credential: TAccountMetas[1];
        /** Credential the Schema is associated with */
        schema: TAccountMetas[2];
    };
    data: ChangeSchemaStatusInstructionData;
};
export declare function parseChangeSchemaStatusInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedChangeSchemaStatusInstruction<TProgram, TAccountMetas>;
