/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlySignerAccount, type ReadonlyUint8Array, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/kit';
import { SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS } from '../programs';
export declare const CHANGE_SCHEMA_VERSION_DISCRIMINATOR = 5;
export declare function getChangeSchemaVersionDiscriminatorBytes(): ReadonlyUint8Array;
export type ChangeSchemaVersionInstruction<TProgram extends string = typeof SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS, TAccountPayer extends string | IAccountMeta<string> = string, TAccountAuthority extends string | IAccountMeta<string> = string, TAccountCredential extends string | IAccountMeta<string> = string, TAccountExistingSchema extends string | IAccountMeta<string> = string, TAccountNewSchema extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountAuthority extends string ? ReadonlySignerAccount<TAccountAuthority> & IAccountSignerMeta<TAccountAuthority> : TAccountAuthority,
    TAccountCredential extends string ? ReadonlyAccount<TAccountCredential> : TAccountCredential,
    TAccountExistingSchema extends string ? ReadonlyAccount<TAccountExistingSchema> : TAccountExistingSchema,
    TAccountNewSchema extends string ? WritableAccount<TAccountNewSchema> : TAccountNewSchema,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type ChangeSchemaVersionInstructionData = {
    discriminator: number;
    layout: ReadonlyUint8Array;
    fieldNames: Array<string>;
};
export type ChangeSchemaVersionInstructionDataArgs = {
    layout: ReadonlyUint8Array;
    fieldNames: Array<string>;
};
export declare function getChangeSchemaVersionInstructionDataEncoder(): Encoder<ChangeSchemaVersionInstructionDataArgs>;
export declare function getChangeSchemaVersionInstructionDataDecoder(): Decoder<ChangeSchemaVersionInstructionData>;
export declare function getChangeSchemaVersionInstructionDataCodec(): Codec<ChangeSchemaVersionInstructionDataArgs, ChangeSchemaVersionInstructionData>;
export type ChangeSchemaVersionInput<TAccountPayer extends string = string, TAccountAuthority extends string = string, TAccountCredential extends string = string, TAccountExistingSchema extends string = string, TAccountNewSchema extends string = string, TAccountSystemProgram extends string = string> = {
    payer: TransactionSigner<TAccountPayer>;
    authority: TransactionSigner<TAccountAuthority>;
    /** Credential the Schema is associated with */
    credential: Address<TAccountCredential>;
    existingSchema: Address<TAccountExistingSchema>;
    newSchema: Address<TAccountNewSchema>;
    systemProgram?: Address<TAccountSystemProgram>;
    layout: ChangeSchemaVersionInstructionDataArgs['layout'];
    fieldNames: ChangeSchemaVersionInstructionDataArgs['fieldNames'];
};
export declare function getChangeSchemaVersionInstruction<TAccountPayer extends string, TAccountAuthority extends string, TAccountCredential extends string, TAccountExistingSchema extends string, TAccountNewSchema extends string, TAccountSystemProgram extends string, TProgramAddress extends Address = typeof SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS>(input: ChangeSchemaVersionInput<TAccountPayer, TAccountAuthority, TAccountCredential, TAccountExistingSchema, TAccountNewSchema, TAccountSystemProgram>, config?: {
    programAddress?: TProgramAddress;
}): ChangeSchemaVersionInstruction<TProgramAddress, TAccountPayer, TAccountAuthority, TAccountCredential, TAccountExistingSchema, TAccountNewSchema, TAccountSystemProgram>;
export type ParsedChangeSchemaVersionInstruction<TProgram extends string = typeof SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        payer: TAccountMetas[0];
        authority: TAccountMetas[1];
        /** Credential the Schema is associated with */
        credential: TAccountMetas[2];
        existingSchema: TAccountMetas[3];
        newSchema: TAccountMetas[4];
        systemProgram: TAccountMetas[5];
    };
    data: ChangeSchemaVersionInstructionData;
};
export declare function parseChangeSchemaVersionInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedChangeSchemaVersionInstruction<TProgram, TAccountMetas>;
