"use strict";
/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.CHANGE_SCHEMA_VERSION_DISCRIMINATOR = void 0;
exports.getChangeSchemaVersionDiscriminatorBytes = getChangeSchemaVersionDiscriminatorBytes;
exports.getChangeSchemaVersionInstructionDataEncoder = getChangeSchemaVersionInstructionDataEncoder;
exports.getChangeSchemaVersionInstructionDataDecoder = getChangeSchemaVersionInstructionDataDecoder;
exports.getChangeSchemaVersionInstructionDataCodec = getChangeSchemaVersionInstructionDataCodec;
exports.getChangeSchemaVersionInstruction = getChangeSchemaVersionInstruction;
exports.parseChangeSchemaVersionInstruction = parseChangeSchemaVersionInstruction;
const kit_1 = require("@solana/kit");
const programs_1 = require("../programs");
const shared_1 = require("../shared");
exports.CHANGE_SCHEMA_VERSION_DISCRIMINATOR = 5;
function getChangeSchemaVersionDiscriminatorBytes() {
    return (0, kit_1.getU8Encoder)().encode(exports.CHANGE_SCHEMA_VERSION_DISCRIMINATOR);
}
function getChangeSchemaVersionInstructionDataEncoder() {
    return (0, kit_1.transformEncoder)((0, kit_1.getStructEncoder)([
        ['discriminator', (0, kit_1.getU8Encoder)()],
        ['layout', (0, kit_1.addEncoderSizePrefix)((0, kit_1.getBytesEncoder)(), (0, kit_1.getU32Encoder)())],
        [
            'fieldNames',
            (0, kit_1.getArrayEncoder)((0, kit_1.addEncoderSizePrefix)((0, kit_1.getUtf8Encoder)(), (0, kit_1.getU32Encoder)())),
        ],
    ]), (value) => ({
        ...value,
        discriminator: exports.CHANGE_SCHEMA_VERSION_DISCRIMINATOR,
    }));
}
function getChangeSchemaVersionInstructionDataDecoder() {
    return (0, kit_1.getStructDecoder)([
        ['discriminator', (0, kit_1.getU8Decoder)()],
        ['layout', (0, kit_1.addDecoderSizePrefix)((0, kit_1.getBytesDecoder)(), (0, kit_1.getU32Decoder)())],
        [
            'fieldNames',
            (0, kit_1.getArrayDecoder)((0, kit_1.addDecoderSizePrefix)((0, kit_1.getUtf8Decoder)(), (0, kit_1.getU32Decoder)())),
        ],
    ]);
}
function getChangeSchemaVersionInstructionDataCodec() {
    return (0, kit_1.combineCodec)(getChangeSchemaVersionInstructionDataEncoder(), getChangeSchemaVersionInstructionDataDecoder());
}
function getChangeSchemaVersionInstruction(input, config) {
    // Program address.
    const programAddress = config?.programAddress ?? programs_1.SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS;
    // Original accounts.
    const originalAccounts = {
        payer: { value: input.payer ?? null, isWritable: true },
        authority: { value: input.authority ?? null, isWritable: false },
        credential: { value: input.credential ?? null, isWritable: false },
        existingSchema: { value: input.existingSchema ?? null, isWritable: false },
        newSchema: { value: input.newSchema ?? null, isWritable: true },
        systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    };
    const accounts = originalAccounts;
    // Original args.
    const args = { ...input };
    // Resolve default values.
    if (!accounts.systemProgram.value) {
        accounts.systemProgram.value =
            '11111111111111111111111111111111';
    }
    const getAccountMeta = (0, shared_1.getAccountMetaFactory)(programAddress, 'programId');
    const instruction = {
        accounts: [
            getAccountMeta(accounts.payer),
            getAccountMeta(accounts.authority),
            getAccountMeta(accounts.credential),
            getAccountMeta(accounts.existingSchema),
            getAccountMeta(accounts.newSchema),
            getAccountMeta(accounts.systemProgram),
        ],
        programAddress,
        data: getChangeSchemaVersionInstructionDataEncoder().encode(args),
    };
    return instruction;
}
function parseChangeSchemaVersionInstruction(instruction) {
    if (instruction.accounts.length < 6) {
        // TODO: Coded error.
        throw new Error('Not enough accounts');
    }
    let accountIndex = 0;
    const getNextAccount = () => {
        const accountMeta = instruction.accounts[accountIndex];
        accountIndex += 1;
        return accountMeta;
    };
    return {
        programAddress: instruction.programAddress,
        accounts: {
            payer: getNextAccount(),
            authority: getNextAccount(),
            credential: getNextAccount(),
            existingSchema: getNextAccount(),
            newSchema: getNextAccount(),
            systemProgram: getNextAccount(),
        },
        data: getChangeSchemaVersionInstructionDataDecoder().decode(instruction.data),
    };
}
