"use strict";
/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.CLOSE_ATTESTATION_DISCRIMINATOR = void 0;
exports.getCloseAttestationDiscriminatorBytes = getCloseAttestationDiscriminatorBytes;
exports.getCloseAttestationInstructionDataEncoder = getCloseAttestationInstructionDataEncoder;
exports.getCloseAttestationInstructionDataDecoder = getCloseAttestationInstructionDataDecoder;
exports.getCloseAttestationInstructionDataCodec = getCloseAttestationInstructionDataCodec;
exports.getCloseAttestationInstruction = getCloseAttestationInstruction;
exports.parseCloseAttestationInstruction = parseCloseAttestationInstruction;
const kit_1 = require("@solana/kit");
const programs_1 = require("../programs");
const shared_1 = require("../shared");
exports.CLOSE_ATTESTATION_DISCRIMINATOR = 7;
function getCloseAttestationDiscriminatorBytes() {
    return (0, kit_1.getU8Encoder)().encode(exports.CLOSE_ATTESTATION_DISCRIMINATOR);
}
function getCloseAttestationInstructionDataEncoder() {
    return (0, kit_1.transformEncoder)((0, kit_1.getStructEncoder)([['discriminator', (0, kit_1.getU8Encoder)()]]), (value) => ({ ...value, discriminator: exports.CLOSE_ATTESTATION_DISCRIMINATOR }));
}
function getCloseAttestationInstructionDataDecoder() {
    return (0, kit_1.getStructDecoder)([['discriminator', (0, kit_1.getU8Decoder)()]]);
}
function getCloseAttestationInstructionDataCodec() {
    return (0, kit_1.combineCodec)(getCloseAttestationInstructionDataEncoder(), getCloseAttestationInstructionDataDecoder());
}
function getCloseAttestationInstruction(input, config) {
    // Program address.
    const programAddress = config?.programAddress ?? programs_1.SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS;
    // Original accounts.
    const originalAccounts = {
        payer: { value: input.payer ?? null, isWritable: true },
        authority: { value: input.authority ?? null, isWritable: false },
        credential: { value: input.credential ?? null, isWritable: false },
        attestation: { value: input.attestation ?? null, isWritable: true },
        eventAuthority: { value: input.eventAuthority ?? null, isWritable: false },
        systemProgram: { value: input.systemProgram ?? null, isWritable: false },
        attestationProgram: {
            value: input.attestationProgram ?? null,
            isWritable: false,
        },
    };
    const accounts = originalAccounts;
    // Resolve default values.
    if (!accounts.systemProgram.value) {
        accounts.systemProgram.value =
            '11111111111111111111111111111111';
    }
    const getAccountMeta = (0, shared_1.getAccountMetaFactory)(programAddress, 'programId');
    const instruction = {
        accounts: [
            getAccountMeta(accounts.payer),
            getAccountMeta(accounts.authority),
            getAccountMeta(accounts.credential),
            getAccountMeta(accounts.attestation),
            getAccountMeta(accounts.eventAuthority),
            getAccountMeta(accounts.systemProgram),
            getAccountMeta(accounts.attestationProgram),
        ],
        programAddress,
        data: getCloseAttestationInstructionDataEncoder().encode({}),
    };
    return instruction;
}
function parseCloseAttestationInstruction(instruction) {
    if (instruction.accounts.length < 7) {
        // TODO: Coded error.
        throw new Error('Not enough accounts');
    }
    let accountIndex = 0;
    const getNextAccount = () => {
        const accountMeta = instruction.accounts[accountIndex];
        accountIndex += 1;
        return accountMeta;
    };
    return {
        programAddress: instruction.programAddress,
        accounts: {
            payer: getNextAccount(),
            authority: getNextAccount(),
            credential: getNextAccount(),
            attestation: getNextAccount(),
            eventAuthority: getNextAccount(),
            systemProgram: getNextAccount(),
            attestationProgram: getNextAccount(),
        },
        data: getCloseAttestationInstructionDataDecoder().decode(instruction.data),
    };
}
