"use strict";
/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.CREATE_ATTESTATION_DISCRIMINATOR = void 0;
exports.getCreateAttestationDiscriminatorBytes = getCreateAttestationDiscriminatorBytes;
exports.getCreateAttestationInstructionDataEncoder = getCreateAttestationInstructionDataEncoder;
exports.getCreateAttestationInstructionDataDecoder = getCreateAttestationInstructionDataDecoder;
exports.getCreateAttestationInstructionDataCodec = getCreateAttestationInstructionDataCodec;
exports.getCreateAttestationInstruction = getCreateAttestationInstruction;
exports.parseCreateAttestationInstruction = parseCreateAttestationInstruction;
const kit_1 = require("@solana/kit");
const programs_1 = require("../programs");
const shared_1 = require("../shared");
exports.CREATE_ATTESTATION_DISCRIMINATOR = 6;
function getCreateAttestationDiscriminatorBytes() {
    return (0, kit_1.getU8Encoder)().encode(exports.CREATE_ATTESTATION_DISCRIMINATOR);
}
function getCreateAttestationInstructionDataEncoder() {
    return (0, kit_1.transformEncoder)((0, kit_1.getStructEncoder)([
        ['discriminator', (0, kit_1.getU8Encoder)()],
        ['nonce', (0, kit_1.getAddressEncoder)()],
        ['data', (0, kit_1.addEncoderSizePrefix)((0, kit_1.getBytesEncoder)(), (0, kit_1.getU32Encoder)())],
        ['expiry', (0, kit_1.getI64Encoder)()],
    ]), (value) => ({ ...value, discriminator: exports.CREATE_ATTESTATION_DISCRIMINATOR }));
}
function getCreateAttestationInstructionDataDecoder() {
    return (0, kit_1.getStructDecoder)([
        ['discriminator', (0, kit_1.getU8Decoder)()],
        ['nonce', (0, kit_1.getAddressDecoder)()],
        ['data', (0, kit_1.addDecoderSizePrefix)((0, kit_1.getBytesDecoder)(), (0, kit_1.getU32Decoder)())],
        ['expiry', (0, kit_1.getI64Decoder)()],
    ]);
}
function getCreateAttestationInstructionDataCodec() {
    return (0, kit_1.combineCodec)(getCreateAttestationInstructionDataEncoder(), getCreateAttestationInstructionDataDecoder());
}
function getCreateAttestationInstruction(input, config) {
    // Program address.
    const programAddress = config?.programAddress ?? programs_1.SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS;
    // Original accounts.
    const originalAccounts = {
        payer: { value: input.payer ?? null, isWritable: true },
        authority: { value: input.authority ?? null, isWritable: false },
        credential: { value: input.credential ?? null, isWritable: false },
        schema: { value: input.schema ?? null, isWritable: false },
        attestation: { value: input.attestation ?? null, isWritable: true },
        systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    };
    const accounts = originalAccounts;
    // Original args.
    const args = { ...input };
    // Resolve default values.
    if (!accounts.systemProgram.value) {
        accounts.systemProgram.value =
            '11111111111111111111111111111111';
    }
    const getAccountMeta = (0, shared_1.getAccountMetaFactory)(programAddress, 'programId');
    const instruction = {
        accounts: [
            getAccountMeta(accounts.payer),
            getAccountMeta(accounts.authority),
            getAccountMeta(accounts.credential),
            getAccountMeta(accounts.schema),
            getAccountMeta(accounts.attestation),
            getAccountMeta(accounts.systemProgram),
        ],
        programAddress,
        data: getCreateAttestationInstructionDataEncoder().encode(args),
    };
    return instruction;
}
function parseCreateAttestationInstruction(instruction) {
    if (instruction.accounts.length < 6) {
        // TODO: Coded error.
        throw new Error('Not enough accounts');
    }
    let accountIndex = 0;
    const getNextAccount = () => {
        const accountMeta = instruction.accounts[accountIndex];
        accountIndex += 1;
        return accountMeta;
    };
    return {
        programAddress: instruction.programAddress,
        accounts: {
            payer: getNextAccount(),
            authority: getNextAccount(),
            credential: getNextAccount(),
            schema: getNextAccount(),
            attestation: getNextAccount(),
            systemProgram: getNextAccount(),
        },
        data: getCreateAttestationInstructionDataDecoder().decode(instruction.data),
    };
}
