/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlySignerAccount, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/kit';
import { SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS } from '../programs';
export declare const CREATE_CREDENTIAL_DISCRIMINATOR = 0;
export declare function getCreateCredentialDiscriminatorBytes(): import("@solana/kit").ReadonlyUint8Array;
export type CreateCredentialInstruction<TProgram extends string = typeof SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS, TAccountPayer extends string | IAccountMeta<string> = string, TAccountCredential extends string | IAccountMeta<string> = string, TAccountAuthority extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountCredential extends string ? WritableAccount<TAccountCredential> : TAccountCredential,
    TAccountAuthority extends string ? ReadonlySignerAccount<TAccountAuthority> & IAccountSignerMeta<TAccountAuthority> : TAccountAuthority,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type CreateCredentialInstructionData = {
    discriminator: number;
    name: string;
    signers: Array<Address>;
};
export type CreateCredentialInstructionDataArgs = {
    name: string;
    signers: Array<Address>;
};
export declare function getCreateCredentialInstructionDataEncoder(): Encoder<CreateCredentialInstructionDataArgs>;
export declare function getCreateCredentialInstructionDataDecoder(): Decoder<CreateCredentialInstructionData>;
export declare function getCreateCredentialInstructionDataCodec(): Codec<CreateCredentialInstructionDataArgs, CreateCredentialInstructionData>;
export type CreateCredentialInput<TAccountPayer extends string = string, TAccountCredential extends string = string, TAccountAuthority extends string = string, TAccountSystemProgram extends string = string> = {
    payer: TransactionSigner<TAccountPayer>;
    credential: Address<TAccountCredential>;
    authority: TransactionSigner<TAccountAuthority>;
    systemProgram?: Address<TAccountSystemProgram>;
    name: CreateCredentialInstructionDataArgs['name'];
    signers: CreateCredentialInstructionDataArgs['signers'];
};
export declare function getCreateCredentialInstruction<TAccountPayer extends string, TAccountCredential extends string, TAccountAuthority extends string, TAccountSystemProgram extends string, TProgramAddress extends Address = typeof SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS>(input: CreateCredentialInput<TAccountPayer, TAccountCredential, TAccountAuthority, TAccountSystemProgram>, config?: {
    programAddress?: TProgramAddress;
}): CreateCredentialInstruction<TProgramAddress, TAccountPayer, TAccountCredential, TAccountAuthority, TAccountSystemProgram>;
export type ParsedCreateCredentialInstruction<TProgram extends string = typeof SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        payer: TAccountMetas[0];
        credential: TAccountMetas[1];
        authority: TAccountMetas[2];
        systemProgram: TAccountMetas[3];
    };
    data: CreateCredentialInstructionData;
};
export declare function parseCreateCredentialInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedCreateCredentialInstruction<TProgram, TAccountMetas>;
