"use strict";
/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.CREATE_CREDENTIAL_DISCRIMINATOR = void 0;
exports.getCreateCredentialDiscriminatorBytes = getCreateCredentialDiscriminatorBytes;
exports.getCreateCredentialInstructionDataEncoder = getCreateCredentialInstructionDataEncoder;
exports.getCreateCredentialInstructionDataDecoder = getCreateCredentialInstructionDataDecoder;
exports.getCreateCredentialInstructionDataCodec = getCreateCredentialInstructionDataCodec;
exports.getCreateCredentialInstruction = getCreateCredentialInstruction;
exports.parseCreateCredentialInstruction = parseCreateCredentialInstruction;
const kit_1 = require("@solana/kit");
const programs_1 = require("../programs");
const shared_1 = require("../shared");
exports.CREATE_CREDENTIAL_DISCRIMINATOR = 0;
function getCreateCredentialDiscriminatorBytes() {
    return (0, kit_1.getU8Encoder)().encode(exports.CREATE_CREDENTIAL_DISCRIMINATOR);
}
function getCreateCredentialInstructionDataEncoder() {
    return (0, kit_1.transformEncoder)((0, kit_1.getStructEncoder)([
        ['discriminator', (0, kit_1.getU8Encoder)()],
        ['name', (0, kit_1.addEncoderSizePrefix)((0, kit_1.getUtf8Encoder)(), (0, kit_1.getU32Encoder)())],
        ['signers', (0, kit_1.getArrayEncoder)((0, kit_1.getAddressEncoder)())],
    ]), (value) => ({ ...value, discriminator: exports.CREATE_CREDENTIAL_DISCRIMINATOR }));
}
function getCreateCredentialInstructionDataDecoder() {
    return (0, kit_1.getStructDecoder)([
        ['discriminator', (0, kit_1.getU8Decoder)()],
        ['name', (0, kit_1.addDecoderSizePrefix)((0, kit_1.getUtf8Decoder)(), (0, kit_1.getU32Decoder)())],
        ['signers', (0, kit_1.getArrayDecoder)((0, kit_1.getAddressDecoder)())],
    ]);
}
function getCreateCredentialInstructionDataCodec() {
    return (0, kit_1.combineCodec)(getCreateCredentialInstructionDataEncoder(), getCreateCredentialInstructionDataDecoder());
}
function getCreateCredentialInstruction(input, config) {
    // Program address.
    const programAddress = config?.programAddress ?? programs_1.SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS;
    // Original accounts.
    const originalAccounts = {
        payer: { value: input.payer ?? null, isWritable: true },
        credential: { value: input.credential ?? null, isWritable: true },
        authority: { value: input.authority ?? null, isWritable: false },
        systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    };
    const accounts = originalAccounts;
    // Original args.
    const args = { ...input };
    // Resolve default values.
    if (!accounts.systemProgram.value) {
        accounts.systemProgram.value =
            '11111111111111111111111111111111';
    }
    const getAccountMeta = (0, shared_1.getAccountMetaFactory)(programAddress, 'programId');
    const instruction = {
        accounts: [
            getAccountMeta(accounts.payer),
            getAccountMeta(accounts.credential),
            getAccountMeta(accounts.authority),
            getAccountMeta(accounts.systemProgram),
        ],
        programAddress,
        data: getCreateCredentialInstructionDataEncoder().encode(args),
    };
    return instruction;
}
function parseCreateCredentialInstruction(instruction) {
    if (instruction.accounts.length < 4) {
        // TODO: Coded error.
        throw new Error('Not enough accounts');
    }
    let accountIndex = 0;
    const getNextAccount = () => {
        const accountMeta = instruction.accounts[accountIndex];
        accountIndex += 1;
        return accountMeta;
    };
    return {
        programAddress: instruction.programAddress,
        accounts: {
            payer: getNextAccount(),
            credential: getNextAccount(),
            authority: getNextAccount(),
            systemProgram: getNextAccount(),
        },
        data: getCreateCredentialInstructionDataDecoder().decode(instruction.data),
    };
}
