/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlySignerAccount, type ReadonlyUint8Array, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/kit';
import { SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS } from '../programs';
export declare const CREATE_SCHEMA_DISCRIMINATOR = 1;
export declare function getCreateSchemaDiscriminatorBytes(): ReadonlyUint8Array;
export type CreateSchemaInstruction<TProgram extends string = typeof SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS, TAccountPayer extends string | IAccountMeta<string> = string, TAccountAuthority extends string | IAccountMeta<string> = string, TAccountCredential extends string | IAccountMeta<string> = string, TAccountSchema extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountAuthority extends string ? ReadonlySignerAccount<TAccountAuthority> & IAccountSignerMeta<TAccountAuthority> : TAccountAuthority,
    TAccountCredential extends string ? ReadonlyAccount<TAccountCredential> : TAccountCredential,
    TAccountSchema extends string ? WritableAccount<TAccountSchema> : TAccountSchema,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type CreateSchemaInstructionData = {
    discriminator: number;
    name: string;
    description: string;
    layout: ReadonlyUint8Array;
    fieldNames: Array<string>;
};
export type CreateSchemaInstructionDataArgs = {
    name: string;
    description: string;
    layout: ReadonlyUint8Array;
    fieldNames: Array<string>;
};
export declare function getCreateSchemaInstructionDataEncoder(): Encoder<CreateSchemaInstructionDataArgs>;
export declare function getCreateSchemaInstructionDataDecoder(): Decoder<CreateSchemaInstructionData>;
export declare function getCreateSchemaInstructionDataCodec(): Codec<CreateSchemaInstructionDataArgs, CreateSchemaInstructionData>;
export type CreateSchemaInput<TAccountPayer extends string = string, TAccountAuthority extends string = string, TAccountCredential extends string = string, TAccountSchema extends string = string, TAccountSystemProgram extends string = string> = {
    payer: TransactionSigner<TAccountPayer>;
    authority: TransactionSigner<TAccountAuthority>;
    /** Credential the Schema is associated with */
    credential: Address<TAccountCredential>;
    schema: Address<TAccountSchema>;
    systemProgram?: Address<TAccountSystemProgram>;
    name: CreateSchemaInstructionDataArgs['name'];
    description: CreateSchemaInstructionDataArgs['description'];
    layout: CreateSchemaInstructionDataArgs['layout'];
    fieldNames: CreateSchemaInstructionDataArgs['fieldNames'];
};
export declare function getCreateSchemaInstruction<TAccountPayer extends string, TAccountAuthority extends string, TAccountCredential extends string, TAccountSchema extends string, TAccountSystemProgram extends string, TProgramAddress extends Address = typeof SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS>(input: CreateSchemaInput<TAccountPayer, TAccountAuthority, TAccountCredential, TAccountSchema, TAccountSystemProgram>, config?: {
    programAddress?: TProgramAddress;
}): CreateSchemaInstruction<TProgramAddress, TAccountPayer, TAccountAuthority, TAccountCredential, TAccountSchema, TAccountSystemProgram>;
export type ParsedCreateSchemaInstruction<TProgram extends string = typeof SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        payer: TAccountMetas[0];
        authority: TAccountMetas[1];
        /** Credential the Schema is associated with */
        credential: TAccountMetas[2];
        schema: TAccountMetas[3];
        systemProgram: TAccountMetas[4];
    };
    data: CreateSchemaInstructionData;
};
export declare function parseCreateSchemaInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedCreateSchemaInstruction<TProgram, TAccountMetas>;
