"use strict";
/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.CREATE_SCHEMA_DISCRIMINATOR = void 0;
exports.getCreateSchemaDiscriminatorBytes = getCreateSchemaDiscriminatorBytes;
exports.getCreateSchemaInstructionDataEncoder = getCreateSchemaInstructionDataEncoder;
exports.getCreateSchemaInstructionDataDecoder = getCreateSchemaInstructionDataDecoder;
exports.getCreateSchemaInstructionDataCodec = getCreateSchemaInstructionDataCodec;
exports.getCreateSchemaInstruction = getCreateSchemaInstruction;
exports.parseCreateSchemaInstruction = parseCreateSchemaInstruction;
const kit_1 = require("@solana/kit");
const programs_1 = require("../programs");
const shared_1 = require("../shared");
exports.CREATE_SCHEMA_DISCRIMINATOR = 1;
function getCreateSchemaDiscriminatorBytes() {
    return (0, kit_1.getU8Encoder)().encode(exports.CREATE_SCHEMA_DISCRIMINATOR);
}
function getCreateSchemaInstructionDataEncoder() {
    return (0, kit_1.transformEncoder)((0, kit_1.getStructEncoder)([
        ['discriminator', (0, kit_1.getU8Encoder)()],
        ['name', (0, kit_1.addEncoderSizePrefix)((0, kit_1.getUtf8Encoder)(), (0, kit_1.getU32Encoder)())],
        ['description', (0, kit_1.addEncoderSizePrefix)((0, kit_1.getUtf8Encoder)(), (0, kit_1.getU32Encoder)())],
        ['layout', (0, kit_1.addEncoderSizePrefix)((0, kit_1.getBytesEncoder)(), (0, kit_1.getU32Encoder)())],
        [
            'fieldNames',
            (0, kit_1.getArrayEncoder)((0, kit_1.addEncoderSizePrefix)((0, kit_1.getUtf8Encoder)(), (0, kit_1.getU32Encoder)())),
        ],
    ]), (value) => ({ ...value, discriminator: exports.CREATE_SCHEMA_DISCRIMINATOR }));
}
function getCreateSchemaInstructionDataDecoder() {
    return (0, kit_1.getStructDecoder)([
        ['discriminator', (0, kit_1.getU8Decoder)()],
        ['name', (0, kit_1.addDecoderSizePrefix)((0, kit_1.getUtf8Decoder)(), (0, kit_1.getU32Decoder)())],
        ['description', (0, kit_1.addDecoderSizePrefix)((0, kit_1.getUtf8Decoder)(), (0, kit_1.getU32Decoder)())],
        ['layout', (0, kit_1.addDecoderSizePrefix)((0, kit_1.getBytesDecoder)(), (0, kit_1.getU32Decoder)())],
        [
            'fieldNames',
            (0, kit_1.getArrayDecoder)((0, kit_1.addDecoderSizePrefix)((0, kit_1.getUtf8Decoder)(), (0, kit_1.getU32Decoder)())),
        ],
    ]);
}
function getCreateSchemaInstructionDataCodec() {
    return (0, kit_1.combineCodec)(getCreateSchemaInstructionDataEncoder(), getCreateSchemaInstructionDataDecoder());
}
function getCreateSchemaInstruction(input, config) {
    // Program address.
    const programAddress = config?.programAddress ?? programs_1.SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS;
    // Original accounts.
    const originalAccounts = {
        payer: { value: input.payer ?? null, isWritable: true },
        authority: { value: input.authority ?? null, isWritable: false },
        credential: { value: input.credential ?? null, isWritable: false },
        schema: { value: input.schema ?? null, isWritable: true },
        systemProgram: { value: input.systemProgram ?? null, isWritable: false },
    };
    const accounts = originalAccounts;
    // Original args.
    const args = { ...input };
    // Resolve default values.
    if (!accounts.systemProgram.value) {
        accounts.systemProgram.value =
            '11111111111111111111111111111111';
    }
    const getAccountMeta = (0, shared_1.getAccountMetaFactory)(programAddress, 'programId');
    const instruction = {
        accounts: [
            getAccountMeta(accounts.payer),
            getAccountMeta(accounts.authority),
            getAccountMeta(accounts.credential),
            getAccountMeta(accounts.schema),
            getAccountMeta(accounts.systemProgram),
        ],
        programAddress,
        data: getCreateSchemaInstructionDataEncoder().encode(args),
    };
    return instruction;
}
function parseCreateSchemaInstruction(instruction) {
    if (instruction.accounts.length < 5) {
        // TODO: Coded error.
        throw new Error('Not enough accounts');
    }
    let accountIndex = 0;
    const getNextAccount = () => {
        const accountMeta = instruction.accounts[accountIndex];
        accountIndex += 1;
        return accountMeta;
    };
    return {
        programAddress: instruction.programAddress,
        accounts: {
            payer: getNextAccount(),
            authority: getNextAccount(),
            credential: getNextAccount(),
            schema: getNextAccount(),
            systemProgram: getNextAccount(),
        },
        data: getCreateSchemaInstructionDataDecoder().decode(instruction.data),
    };
}
