/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlySignerAccount, type ReadonlyUint8Array, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/kit';
import { SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS } from '../programs';
export declare const CREATE_TOKENIZED_ATTESTATION_DISCRIMINATOR = 10;
export declare function getCreateTokenizedAttestationDiscriminatorBytes(): ReadonlyUint8Array;
export type CreateTokenizedAttestationInstruction<TProgram extends string = typeof SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS, TAccountPayer extends string | IAccountMeta<string> = string, TAccountAuthority extends string | IAccountMeta<string> = string, TAccountCredential extends string | IAccountMeta<string> = string, TAccountSchema extends string | IAccountMeta<string> = string, TAccountAttestation extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountSchemaMint extends string | IAccountMeta<string> = string, TAccountAttestationMint extends string | IAccountMeta<string> = string, TAccountSasPda extends string | IAccountMeta<string> = string, TAccountRecipientTokenAccount extends string | IAccountMeta<string> = string, TAccountRecipient extends string | IAccountMeta<string> = string, TAccountTokenProgram extends string | IAccountMeta<string> = 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA', TAccountAssociatedTokenProgram extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountAuthority extends string ? ReadonlySignerAccount<TAccountAuthority> & IAccountSignerMeta<TAccountAuthority> : TAccountAuthority,
    TAccountCredential extends string ? ReadonlyAccount<TAccountCredential> : TAccountCredential,
    TAccountSchema extends string ? ReadonlyAccount<TAccountSchema> : TAccountSchema,
    TAccountAttestation extends string ? WritableAccount<TAccountAttestation> : TAccountAttestation,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountSchemaMint extends string ? WritableAccount<TAccountSchemaMint> : TAccountSchemaMint,
    TAccountAttestationMint extends string ? WritableAccount<TAccountAttestationMint> : TAccountAttestationMint,
    TAccountSasPda extends string ? ReadonlyAccount<TAccountSasPda> : TAccountSasPda,
    TAccountRecipientTokenAccount extends string ? WritableAccount<TAccountRecipientTokenAccount> : TAccountRecipientTokenAccount,
    TAccountRecipient extends string ? ReadonlyAccount<TAccountRecipient> : TAccountRecipient,
    TAccountTokenProgram extends string ? ReadonlyAccount<TAccountTokenProgram> : TAccountTokenProgram,
    TAccountAssociatedTokenProgram extends string ? ReadonlyAccount<TAccountAssociatedTokenProgram> : TAccountAssociatedTokenProgram,
    ...TRemainingAccounts
]>;
export type CreateTokenizedAttestationInstructionData = {
    discriminator: number;
    nonce: Address;
    data: ReadonlyUint8Array;
    expiry: bigint;
    name: string;
    uri: string;
    symbol: string;
    mintAccountSpace: number;
};
export type CreateTokenizedAttestationInstructionDataArgs = {
    nonce: Address;
    data: ReadonlyUint8Array;
    expiry: number | bigint;
    name: string;
    uri: string;
    symbol: string;
    mintAccountSpace: number;
};
export declare function getCreateTokenizedAttestationInstructionDataEncoder(): Encoder<CreateTokenizedAttestationInstructionDataArgs>;
export declare function getCreateTokenizedAttestationInstructionDataDecoder(): Decoder<CreateTokenizedAttestationInstructionData>;
export declare function getCreateTokenizedAttestationInstructionDataCodec(): Codec<CreateTokenizedAttestationInstructionDataArgs, CreateTokenizedAttestationInstructionData>;
export type CreateTokenizedAttestationInput<TAccountPayer extends string = string, TAccountAuthority extends string = string, TAccountCredential extends string = string, TAccountSchema extends string = string, TAccountAttestation extends string = string, TAccountSystemProgram extends string = string, TAccountSchemaMint extends string = string, TAccountAttestationMint extends string = string, TAccountSasPda extends string = string, TAccountRecipientTokenAccount extends string = string, TAccountRecipient extends string = string, TAccountTokenProgram extends string = string, TAccountAssociatedTokenProgram extends string = string> = {
    payer: TransactionSigner<TAccountPayer>;
    /** Authorized signer of the Schema's Credential */
    authority: TransactionSigner<TAccountAuthority>;
    /** Credential the Schema is associated with */
    credential: Address<TAccountCredential>;
    /** Schema the Attestation is associated with */
    schema: Address<TAccountSchema>;
    attestation: Address<TAccountAttestation>;
    systemProgram?: Address<TAccountSystemProgram>;
    /** Mint of Schema Token */
    schemaMint: Address<TAccountSchemaMint>;
    /** Mint of Attestation Token */
    attestationMint: Address<TAccountAttestationMint>;
    /** Program derived address used as program signer authority */
    sasPda: Address<TAccountSasPda>;
    /** Associated token account of Recipient for Attestation Token */
    recipientTokenAccount: Address<TAccountRecipientTokenAccount>;
    /** Wallet to receive Attestation Token */
    recipient: Address<TAccountRecipient>;
    tokenProgram?: Address<TAccountTokenProgram>;
    associatedTokenProgram: Address<TAccountAssociatedTokenProgram>;
    nonce: CreateTokenizedAttestationInstructionDataArgs['nonce'];
    data: CreateTokenizedAttestationInstructionDataArgs['data'];
    expiry: CreateTokenizedAttestationInstructionDataArgs['expiry'];
    name: CreateTokenizedAttestationInstructionDataArgs['name'];
    uri: CreateTokenizedAttestationInstructionDataArgs['uri'];
    symbol: CreateTokenizedAttestationInstructionDataArgs['symbol'];
    mintAccountSpace: CreateTokenizedAttestationInstructionDataArgs['mintAccountSpace'];
};
export declare function getCreateTokenizedAttestationInstruction<TAccountPayer extends string, TAccountAuthority extends string, TAccountCredential extends string, TAccountSchema extends string, TAccountAttestation extends string, TAccountSystemProgram extends string, TAccountSchemaMint extends string, TAccountAttestationMint extends string, TAccountSasPda extends string, TAccountRecipientTokenAccount extends string, TAccountRecipient extends string, TAccountTokenProgram extends string, TAccountAssociatedTokenProgram extends string, TProgramAddress extends Address = typeof SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS>(input: CreateTokenizedAttestationInput<TAccountPayer, TAccountAuthority, TAccountCredential, TAccountSchema, TAccountAttestation, TAccountSystemProgram, TAccountSchemaMint, TAccountAttestationMint, TAccountSasPda, TAccountRecipientTokenAccount, TAccountRecipient, TAccountTokenProgram, TAccountAssociatedTokenProgram>, config?: {
    programAddress?: TProgramAddress;
}): CreateTokenizedAttestationInstruction<TProgramAddress, TAccountPayer, TAccountAuthority, TAccountCredential, TAccountSchema, TAccountAttestation, TAccountSystemProgram, TAccountSchemaMint, TAccountAttestationMint, TAccountSasPda, TAccountRecipientTokenAccount, TAccountRecipient, TAccountTokenProgram, TAccountAssociatedTokenProgram>;
export type ParsedCreateTokenizedAttestationInstruction<TProgram extends string = typeof SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        payer: TAccountMetas[0];
        /** Authorized signer of the Schema's Credential */
        authority: TAccountMetas[1];
        /** Credential the Schema is associated with */
        credential: TAccountMetas[2];
        /** Schema the Attestation is associated with */
        schema: TAccountMetas[3];
        attestation: TAccountMetas[4];
        systemProgram: TAccountMetas[5];
        /** Mint of Schema Token */
        schemaMint: TAccountMetas[6];
        /** Mint of Attestation Token */
        attestationMint: TAccountMetas[7];
        /** Program derived address used as program signer authority */
        sasPda: TAccountMetas[8];
        /** Associated token account of Recipient for Attestation Token */
        recipientTokenAccount: TAccountMetas[9];
        /** Wallet to receive Attestation Token */
        recipient: TAccountMetas[10];
        tokenProgram: TAccountMetas[11];
        associatedTokenProgram: TAccountMetas[12];
    };
    data: CreateTokenizedAttestationInstructionData;
};
export declare function parseCreateTokenizedAttestationInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedCreateTokenizedAttestationInstruction<TProgram, TAccountMetas>;
