"use strict";
/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.CREATE_TOKENIZED_ATTESTATION_DISCRIMINATOR = void 0;
exports.getCreateTokenizedAttestationDiscriminatorBytes = getCreateTokenizedAttestationDiscriminatorBytes;
exports.getCreateTokenizedAttestationInstructionDataEncoder = getCreateTokenizedAttestationInstructionDataEncoder;
exports.getCreateTokenizedAttestationInstructionDataDecoder = getCreateTokenizedAttestationInstructionDataDecoder;
exports.getCreateTokenizedAttestationInstructionDataCodec = getCreateTokenizedAttestationInstructionDataCodec;
exports.getCreateTokenizedAttestationInstruction = getCreateTokenizedAttestationInstruction;
exports.parseCreateTokenizedAttestationInstruction = parseCreateTokenizedAttestationInstruction;
const kit_1 = require("@solana/kit");
const programs_1 = require("../programs");
const shared_1 = require("../shared");
exports.CREATE_TOKENIZED_ATTESTATION_DISCRIMINATOR = 10;
function getCreateTokenizedAttestationDiscriminatorBytes() {
    return (0, kit_1.getU8Encoder)().encode(exports.CREATE_TOKENIZED_ATTESTATION_DISCRIMINATOR);
}
function getCreateTokenizedAttestationInstructionDataEncoder() {
    return (0, kit_1.transformEncoder)((0, kit_1.getStructEncoder)([
        ['discriminator', (0, kit_1.getU8Encoder)()],
        ['nonce', (0, kit_1.getAddressEncoder)()],
        ['data', (0, kit_1.addEncoderSizePrefix)((0, kit_1.getBytesEncoder)(), (0, kit_1.getU32Encoder)())],
        ['expiry', (0, kit_1.getI64Encoder)()],
        ['name', (0, kit_1.addEncoderSizePrefix)((0, kit_1.getUtf8Encoder)(), (0, kit_1.getU32Encoder)())],
        ['uri', (0, kit_1.addEncoderSizePrefix)((0, kit_1.getUtf8Encoder)(), (0, kit_1.getU32Encoder)())],
        ['symbol', (0, kit_1.addEncoderSizePrefix)((0, kit_1.getUtf8Encoder)(), (0, kit_1.getU32Encoder)())],
        ['mintAccountSpace', (0, kit_1.getU16Encoder)()],
    ]), (value) => ({
        ...value,
        discriminator: exports.CREATE_TOKENIZED_ATTESTATION_DISCRIMINATOR,
    }));
}
function getCreateTokenizedAttestationInstructionDataDecoder() {
    return (0, kit_1.getStructDecoder)([
        ['discriminator', (0, kit_1.getU8Decoder)()],
        ['nonce', (0, kit_1.getAddressDecoder)()],
        ['data', (0, kit_1.addDecoderSizePrefix)((0, kit_1.getBytesDecoder)(), (0, kit_1.getU32Decoder)())],
        ['expiry', (0, kit_1.getI64Decoder)()],
        ['name', (0, kit_1.addDecoderSizePrefix)((0, kit_1.getUtf8Decoder)(), (0, kit_1.getU32Decoder)())],
        ['uri', (0, kit_1.addDecoderSizePrefix)((0, kit_1.getUtf8Decoder)(), (0, kit_1.getU32Decoder)())],
        ['symbol', (0, kit_1.addDecoderSizePrefix)((0, kit_1.getUtf8Decoder)(), (0, kit_1.getU32Decoder)())],
        ['mintAccountSpace', (0, kit_1.getU16Decoder)()],
    ]);
}
function getCreateTokenizedAttestationInstructionDataCodec() {
    return (0, kit_1.combineCodec)(getCreateTokenizedAttestationInstructionDataEncoder(), getCreateTokenizedAttestationInstructionDataDecoder());
}
function getCreateTokenizedAttestationInstruction(input, config) {
    // Program address.
    const programAddress = config?.programAddress ?? programs_1.SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS;
    // Original accounts.
    const originalAccounts = {
        payer: { value: input.payer ?? null, isWritable: true },
        authority: { value: input.authority ?? null, isWritable: false },
        credential: { value: input.credential ?? null, isWritable: false },
        schema: { value: input.schema ?? null, isWritable: false },
        attestation: { value: input.attestation ?? null, isWritable: true },
        systemProgram: { value: input.systemProgram ?? null, isWritable: false },
        schemaMint: { value: input.schemaMint ?? null, isWritable: true },
        attestationMint: { value: input.attestationMint ?? null, isWritable: true },
        sasPda: { value: input.sasPda ?? null, isWritable: false },
        recipientTokenAccount: {
            value: input.recipientTokenAccount ?? null,
            isWritable: true,
        },
        recipient: { value: input.recipient ?? null, isWritable: false },
        tokenProgram: { value: input.tokenProgram ?? null, isWritable: false },
        associatedTokenProgram: {
            value: input.associatedTokenProgram ?? null,
            isWritable: false,
        },
    };
    const accounts = originalAccounts;
    // Original args.
    const args = { ...input };
    // Resolve default values.
    if (!accounts.systemProgram.value) {
        accounts.systemProgram.value =
            '11111111111111111111111111111111';
    }
    if (!accounts.tokenProgram.value) {
        accounts.tokenProgram.value =
            'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA';
    }
    const getAccountMeta = (0, shared_1.getAccountMetaFactory)(programAddress, 'programId');
    const instruction = {
        accounts: [
            getAccountMeta(accounts.payer),
            getAccountMeta(accounts.authority),
            getAccountMeta(accounts.credential),
            getAccountMeta(accounts.schema),
            getAccountMeta(accounts.attestation),
            getAccountMeta(accounts.systemProgram),
            getAccountMeta(accounts.schemaMint),
            getAccountMeta(accounts.attestationMint),
            getAccountMeta(accounts.sasPda),
            getAccountMeta(accounts.recipientTokenAccount),
            getAccountMeta(accounts.recipient),
            getAccountMeta(accounts.tokenProgram),
            getAccountMeta(accounts.associatedTokenProgram),
        ],
        programAddress,
        data: getCreateTokenizedAttestationInstructionDataEncoder().encode(args),
    };
    return instruction;
}
function parseCreateTokenizedAttestationInstruction(instruction) {
    if (instruction.accounts.length < 13) {
        // TODO: Coded error.
        throw new Error('Not enough accounts');
    }
    let accountIndex = 0;
    const getNextAccount = () => {
        const accountMeta = instruction.accounts[accountIndex];
        accountIndex += 1;
        return accountMeta;
    };
    return {
        programAddress: instruction.programAddress,
        accounts: {
            payer: getNextAccount(),
            authority: getNextAccount(),
            credential: getNextAccount(),
            schema: getNextAccount(),
            attestation: getNextAccount(),
            systemProgram: getNextAccount(),
            schemaMint: getNextAccount(),
            attestationMint: getNextAccount(),
            sasPda: getNextAccount(),
            recipientTokenAccount: getNextAccount(),
            recipient: getNextAccount(),
            tokenProgram: getNextAccount(),
            associatedTokenProgram: getNextAccount(),
        },
        data: getCreateTokenizedAttestationInstructionDataDecoder().decode(instruction.data),
    };
}
