"use strict";
/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.EMIT_EVENT_DISCRIMINATOR = void 0;
exports.getEmitEventDiscriminatorBytes = getEmitEventDiscriminatorBytes;
exports.getEmitEventInstructionDataEncoder = getEmitEventInstructionDataEncoder;
exports.getEmitEventInstructionDataDecoder = getEmitEventInstructionDataDecoder;
exports.getEmitEventInstructionDataCodec = getEmitEventInstructionDataCodec;
exports.getEmitEventInstruction = getEmitEventInstruction;
exports.parseEmitEventInstruction = parseEmitEventInstruction;
const kit_1 = require("@solana/kit");
const programs_1 = require("../programs");
const shared_1 = require("../shared");
exports.EMIT_EVENT_DISCRIMINATOR = 8;
function getEmitEventDiscriminatorBytes() {
    return (0, kit_1.getU8Encoder)().encode(exports.EMIT_EVENT_DISCRIMINATOR);
}
function getEmitEventInstructionDataEncoder() {
    return (0, kit_1.transformEncoder)((0, kit_1.getStructEncoder)([['discriminator', (0, kit_1.getU8Encoder)()]]), (value) => ({ ...value, discriminator: exports.EMIT_EVENT_DISCRIMINATOR }));
}
function getEmitEventInstructionDataDecoder() {
    return (0, kit_1.getStructDecoder)([['discriminator', (0, kit_1.getU8Decoder)()]]);
}
function getEmitEventInstructionDataCodec() {
    return (0, kit_1.combineCodec)(getEmitEventInstructionDataEncoder(), getEmitEventInstructionDataDecoder());
}
function getEmitEventInstruction(input, config) {
    // Program address.
    const programAddress = config?.programAddress ?? programs_1.SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS;
    // Original accounts.
    const originalAccounts = {
        eventAuthority: { value: input.eventAuthority ?? null, isWritable: false },
        attestationProgram: {
            value: input.attestationProgram ?? null,
            isWritable: false,
        },
    };
    const accounts = originalAccounts;
    const getAccountMeta = (0, shared_1.getAccountMetaFactory)(programAddress, 'programId');
    const instruction = {
        accounts: [
            getAccountMeta(accounts.eventAuthority),
            getAccountMeta(accounts.attestationProgram),
        ],
        programAddress,
        data: getEmitEventInstructionDataEncoder().encode({}),
    };
    return instruction;
}
function parseEmitEventInstruction(instruction) {
    if (instruction.accounts.length < 2) {
        // TODO: Coded error.
        throw new Error('Not enough accounts');
    }
    let accountIndex = 0;
    const getNextAccount = () => {
        const accountMeta = instruction.accounts[accountIndex];
        accountIndex += 1;
        return accountMeta;
    };
    return {
        programAddress: instruction.programAddress,
        accounts: {
            eventAuthority: getNextAccount(),
            attestationProgram: getNextAccount(),
        },
        data: getEmitEventInstructionDataDecoder().decode(instruction.data),
    };
}
