/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlySignerAccount, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/kit';
import { SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS } from '../programs';
export declare const TOKENIZE_SCHEMA_DISCRIMINATOR = 9;
export declare function getTokenizeSchemaDiscriminatorBytes(): import("@solana/kit").ReadonlyUint8Array;
export type TokenizeSchemaInstruction<TProgram extends string = typeof SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS, TAccountPayer extends string | IAccountMeta<string> = string, TAccountAuthority extends string | IAccountMeta<string> = string, TAccountCredential extends string | IAccountMeta<string> = string, TAccountSchema extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountSasPda extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountTokenProgram extends string | IAccountMeta<string> = 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountAuthority extends string ? ReadonlySignerAccount<TAccountAuthority> & IAccountSignerMeta<TAccountAuthority> : TAccountAuthority,
    TAccountCredential extends string ? ReadonlyAccount<TAccountCredential> : TAccountCredential,
    TAccountSchema extends string ? ReadonlyAccount<TAccountSchema> : TAccountSchema,
    TAccountMint extends string ? WritableAccount<TAccountMint> : TAccountMint,
    TAccountSasPda extends string ? ReadonlyAccount<TAccountSasPda> : TAccountSasPda,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountTokenProgram extends string ? ReadonlyAccount<TAccountTokenProgram> : TAccountTokenProgram,
    ...TRemainingAccounts
]>;
export type TokenizeSchemaInstructionData = {
    discriminator: number;
    maxSize: bigint;
};
export type TokenizeSchemaInstructionDataArgs = {
    maxSize: number | bigint;
};
export declare function getTokenizeSchemaInstructionDataEncoder(): Encoder<TokenizeSchemaInstructionDataArgs>;
export declare function getTokenizeSchemaInstructionDataDecoder(): Decoder<TokenizeSchemaInstructionData>;
export declare function getTokenizeSchemaInstructionDataCodec(): Codec<TokenizeSchemaInstructionDataArgs, TokenizeSchemaInstructionData>;
export type TokenizeSchemaInput<TAccountPayer extends string = string, TAccountAuthority extends string = string, TAccountCredential extends string = string, TAccountSchema extends string = string, TAccountMint extends string = string, TAccountSasPda extends string = string, TAccountSystemProgram extends string = string, TAccountTokenProgram extends string = string> = {
    payer: TransactionSigner<TAccountPayer>;
    authority: TransactionSigner<TAccountAuthority>;
    /** Credential the Schema is associated with */
    credential: Address<TAccountCredential>;
    schema: Address<TAccountSchema>;
    /** Mint of Schema Token */
    mint: Address<TAccountMint>;
    /** Program derived address used as program signer authority */
    sasPda: Address<TAccountSasPda>;
    systemProgram?: Address<TAccountSystemProgram>;
    tokenProgram?: Address<TAccountTokenProgram>;
    maxSize: TokenizeSchemaInstructionDataArgs['maxSize'];
};
export declare function getTokenizeSchemaInstruction<TAccountPayer extends string, TAccountAuthority extends string, TAccountCredential extends string, TAccountSchema extends string, TAccountMint extends string, TAccountSasPda extends string, TAccountSystemProgram extends string, TAccountTokenProgram extends string, TProgramAddress extends Address = typeof SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS>(input: TokenizeSchemaInput<TAccountPayer, TAccountAuthority, TAccountCredential, TAccountSchema, TAccountMint, TAccountSasPda, TAccountSystemProgram, TAccountTokenProgram>, config?: {
    programAddress?: TProgramAddress;
}): TokenizeSchemaInstruction<TProgramAddress, TAccountPayer, TAccountAuthority, TAccountCredential, TAccountSchema, TAccountMint, TAccountSasPda, TAccountSystemProgram, TAccountTokenProgram>;
export type ParsedTokenizeSchemaInstruction<TProgram extends string = typeof SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        payer: TAccountMetas[0];
        authority: TAccountMetas[1];
        /** Credential the Schema is associated with */
        credential: TAccountMetas[2];
        schema: TAccountMetas[3];
        /** Mint of Schema Token */
        mint: TAccountMetas[4];
        /** Program derived address used as program signer authority */
        sasPda: TAccountMetas[5];
        systemProgram: TAccountMetas[6];
        tokenProgram: TAccountMetas[7];
    };
    data: TokenizeSchemaInstructionData;
};
export declare function parseTokenizeSchemaInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedTokenizeSchemaInstruction<TProgram, TAccountMetas>;
