"use strict";
/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.TOKENIZE_SCHEMA_DISCRIMINATOR = void 0;
exports.getTokenizeSchemaDiscriminatorBytes = getTokenizeSchemaDiscriminatorBytes;
exports.getTokenizeSchemaInstructionDataEncoder = getTokenizeSchemaInstructionDataEncoder;
exports.getTokenizeSchemaInstructionDataDecoder = getTokenizeSchemaInstructionDataDecoder;
exports.getTokenizeSchemaInstructionDataCodec = getTokenizeSchemaInstructionDataCodec;
exports.getTokenizeSchemaInstruction = getTokenizeSchemaInstruction;
exports.parseTokenizeSchemaInstruction = parseTokenizeSchemaInstruction;
const kit_1 = require("@solana/kit");
const programs_1 = require("../programs");
const shared_1 = require("../shared");
exports.TOKENIZE_SCHEMA_DISCRIMINATOR = 9;
function getTokenizeSchemaDiscriminatorBytes() {
    return (0, kit_1.getU8Encoder)().encode(exports.TOKENIZE_SCHEMA_DISCRIMINATOR);
}
function getTokenizeSchemaInstructionDataEncoder() {
    return (0, kit_1.transformEncoder)((0, kit_1.getStructEncoder)([
        ['discriminator', (0, kit_1.getU8Encoder)()],
        ['maxSize', (0, kit_1.getU64Encoder)()],
    ]), (value) => ({ ...value, discriminator: exports.TOKENIZE_SCHEMA_DISCRIMINATOR }));
}
function getTokenizeSchemaInstructionDataDecoder() {
    return (0, kit_1.getStructDecoder)([
        ['discriminator', (0, kit_1.getU8Decoder)()],
        ['maxSize', (0, kit_1.getU64Decoder)()],
    ]);
}
function getTokenizeSchemaInstructionDataCodec() {
    return (0, kit_1.combineCodec)(getTokenizeSchemaInstructionDataEncoder(), getTokenizeSchemaInstructionDataDecoder());
}
function getTokenizeSchemaInstruction(input, config) {
    // Program address.
    const programAddress = config?.programAddress ?? programs_1.SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS;
    // Original accounts.
    const originalAccounts = {
        payer: { value: input.payer ?? null, isWritable: true },
        authority: { value: input.authority ?? null, isWritable: false },
        credential: { value: input.credential ?? null, isWritable: false },
        schema: { value: input.schema ?? null, isWritable: false },
        mint: { value: input.mint ?? null, isWritable: true },
        sasPda: { value: input.sasPda ?? null, isWritable: false },
        systemProgram: { value: input.systemProgram ?? null, isWritable: false },
        tokenProgram: { value: input.tokenProgram ?? null, isWritable: false },
    };
    const accounts = originalAccounts;
    // Original args.
    const args = { ...input };
    // Resolve default values.
    if (!accounts.systemProgram.value) {
        accounts.systemProgram.value =
            '11111111111111111111111111111111';
    }
    if (!accounts.tokenProgram.value) {
        accounts.tokenProgram.value =
            'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA';
    }
    const getAccountMeta = (0, shared_1.getAccountMetaFactory)(programAddress, 'programId');
    const instruction = {
        accounts: [
            getAccountMeta(accounts.payer),
            getAccountMeta(accounts.authority),
            getAccountMeta(accounts.credential),
            getAccountMeta(accounts.schema),
            getAccountMeta(accounts.mint),
            getAccountMeta(accounts.sasPda),
            getAccountMeta(accounts.systemProgram),
            getAccountMeta(accounts.tokenProgram),
        ],
        programAddress,
        data: getTokenizeSchemaInstructionDataEncoder().encode(args),
    };
    return instruction;
}
function parseTokenizeSchemaInstruction(instruction) {
    if (instruction.accounts.length < 8) {
        // TODO: Coded error.
        throw new Error('Not enough accounts');
    }
    let accountIndex = 0;
    const getNextAccount = () => {
        const accountMeta = instruction.accounts[accountIndex];
        accountIndex += 1;
        return accountMeta;
    };
    return {
        programAddress: instruction.programAddress,
        accounts: {
            payer: getNextAccount(),
            authority: getNextAccount(),
            credential: getNextAccount(),
            schema: getNextAccount(),
            mint: getNextAccount(),
            sasPda: getNextAccount(),
            systemProgram: getNextAccount(),
            tokenProgram: getNextAccount(),
        },
        data: getTokenizeSchemaInstructionDataDecoder().decode(instruction.data),
    };
}
